#include <gtk/gtk.h>

void file_quit_cmd_callback(GtkWidget *widget, gpointer data);
void file_open_cmd_callback (GtkWidget *widget, gpointer data);

static GtkMenuEntry menu_items[] =
{
	{"File/New", "<control>N", NULL, NULL},
	{"File/Open", "<control>O", file_open_cmd_callback, NULL},
	{"File/Save", "<control>S", NULL, NULL},
	{"File/Save as", NULL, NULL, NULL},
	{"File/<separator>", NULL, NULL, NULL},
	{"File/Quit", "<control>Q", file_quit_cmd_callback,
	 "...und Tsch!\n"},
	{"Options/Test", "<control>T", NULL, NULL}
};
int nmenu_items = sizeof(menu_items) / sizeof(menu_items[0]);

GtkWidget *window;
GtkWidget *main_vbox;
GtkWidget *menubar;
GtkMenuFactory *mfactory;


void
file_open_cmd_callback(GtkWidget *widget, gpointer data) 
{
  GtkWidget *filew;
  
  filew = gtk_file_selection_new ("File selection");
  
  gtk_signal_connect_object (GTK_OBJECT 
	     (GTK_FILE_SELECTION (filew)->ok_button),
	     "clicked", (GtkSignalFunc) gtk_widget_destroy, 
	     GTK_OBJECT (filew));
  
  gtk_signal_connect_object (GTK_OBJECT
	     (GTK_FILE_SELECTION (filew)->cancel_button),
	     "clicked", (GtkSignalFunc) gtk_widget_destroy,
	     GTK_OBJECT (filew));
  gtk_widget_show(filew);
}

void 
file_quit_cmd_callback (GtkWidget *widget, gpointer data)
{
  g_print ("%s\n", (char *) data);
  gtk_exit(0);
}

int
main(int argc, char *argv[]) {

  gtk_init(&argc, &argv);

  gtk_rc_parse("menutestrc");

  window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title(GTK_WINDOW(window), "Gtk Menu Factory");
  gtk_widget_set_usize(GTK_WIDGET(window), 300, 200);

  gtk_signal_connect(GTK_OBJECT(window), "destroy", 
		     GTK_SIGNAL_FUNC(file_quit_cmd_callback), 
		     "WM destroy");  

  main_vbox = gtk_vbox_new(FALSE, 1);
  gtk_container_border_width(GTK_CONTAINER(main_vbox), 1);
  gtk_container_add(GTK_CONTAINER(window), main_vbox);
  gtk_widget_show(main_vbox);

  mfactory = gtk_menu_factory_new(GTK_MENU_FACTORY_MENU_BAR);
  gtk_menu_factory_add_entries(mfactory, menu_items, nmenu_items);
  gtk_window_add_accelerator_table(GTK_WINDOW(window), 
				   mfactory->table);
  menubar = mfactory->widget;
  gtk_box_pack_start(GTK_BOX(main_vbox), menubar, FALSE, TRUE, 0);
  gtk_widget_show(menubar);
  
  gtk_widget_show(window);
  gtk_main();
          
  return(0);
}
